(define-module (ui squid commit ajax)
  :use-module (srfi srfi-1)
  :use-module (alterator ajax)
  :use-module (alterator woo)
  :export (init))

(define autoback #f)

(define (go-back)
  (set! autoback #f)
  (form-replace "/squid"))

(define (on-init)
  (let ((data (woo-read-first "/squid-commit")))
    (form-update-value "update" (woo-get-option data 'update))
    (if (not autoback)
        (form-update-value "status" (woo-get-option data 'status)))
    (form-update-value "backup_dir" (woo-get-option data 'backup_dir))
    (cond
     ((woo-get-option data 'helper)
      (form-update-activity "commit" #f)
      (form-set-timeout on-init 5))
     (else
      (form-update-activity "commit" #t)
      (if autoback
          (go-back))))))

(define (on-commit)
  (catch/message
   (lambda ()
     (woo-write "/squid-commit" 'commit #t
                'status (form-value "status"))
     (set! autoback #t)
     (on-init))))

(define (init)
  (form-bind "commit" "click" on-commit)
  (form-bind "back" "click" go-back)
  (on-init))
